#include <f77/f77_floatingpoint.h>

	subroutine exceptions(of, uf, flag)
	logical of, uf, flag

      integer           noEX, divisionEX, inexactEX, invalidEX,
     &                  overflowEX, underflowEX, seriousEX
      parameter       ( noEX = 0,
     &                  divisionEX  = lshift( 1, fp_division ),
     &                  inexactEX   = lshift( 1, fp_inexact ),
     &                  invalidEX   = lshift( 1, fp_invalid ),
     &                  overflowEX  = lshift( 1, fp_overflow ),
     &                  underflowEX = lshift( 1, fp_underflow ),
     &                  seriousEX   = or( divisionEX,
     &                                or( underflowEX,
     &                                or( overflowEX,
     &                                    invalidEX ) ) ) )


c  Need to define progam variables before declaring the
c  statement functions.


c      real  x, y, z
      integer ieeer, ieee_flags
      character*16 out


c  Definitions of the statement functions used to manipulate
c  floating point exception flags.


      logical fpException, underflow, overflow, invalid, zeroDivide
      integer EXflags
      fpException( EXflags ) = ( and( seriousEX, EXflags ) .ne. 0 )
      underflow( EXflags ) = ( and( underflowEX, EXflags ) .ne. 0 )
      overflow( EXflags ) = ( and( overflowEX, EXflags ) .ne. 0 )
      invalid( EXflags ) = ( and( invalidEX, EXflags ) .ne. 0 )
      zeroDivide( EXflags ) = ( and( divisionEX, EXflags ) .ne. 0 )


c  Check the exception flags.


      ieeer = ieee_flags( 'get', 'exception', 'all', out )


c  "Out" will contain the name of the exception of highest priority,
c  but ieeer will have a bit set for each exception that occured.

      uf=.false.
      of=.false.
      flag=.false.

      if ( underflow( ieeer ) ) then
	 uf=.true.
      endif
      if ( overflow( ieeer ) ) then
	of=.true.
      endif
      if ( zeroDivide( ieeer ) ) then
	 flag=.true.
      endif
      if ( invalid( ieeer ) ) then
	 flag=.true.
      endif


c Now clear the flags so we don't get a message about the 
c exceptions after our program finishes. 

      ieeer = ieee_flags( 'clear', 'exception', 'all', out )  
      end

